require "import"
import "android.app.*"
import "android.os.*"
import "android.widget.*"
import "android.view.*"

activity.setContentView
(
{
  LinearLayout,
  orientation = "vertical",
  layout_width = "fill",
  layout_height = "fill",
  background = "#4488CCFF",
  padding = "20dp",
  focusable=true,
  focusableInTouchMode=true,
  {
    EditText,
    id = "输入框",
    layout_width = "match_parent",
    layout_height = "wrap_content",
    hint = "请输入文本",
    textSize = "18sp",
    background = "#FFFFFF",
    padding = "10dp",
    focusable = true,
    focusableInTouchMode = true,
    singleLine = true,
  },
  {
    Button,
    layout_width = "120dp",
    layout_height = "wrap_content",
    layout_gravity = "center_horizontal",
    text = "分析文本",
    textSize = "18sp",
    onClick = function()
      local 输入内容 = 输入框.getText().toString()
      local 分析结果 = 分析文本(输入内容)
      结果视图.setText(分析结果)
    end
  },
  {
    View,
    layout_width="match_parent",
    layout_height="2dp",
    background="#666666"
  },
  {
    ScrollView,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    {
      TextView,
      id = "结果视图",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      textSize = "16sp",
      textColor = "#333333",
      padding = "10dp",
      text = "此处用于显示结果"
    }
  }
}
)

function 分析文本(文本)
  local 有效, 位置 = utf8.len(文本)
  if not 有效 then
    return "⚠无效的UTF-8序列（错误位置："..位置.."）"
  end
  local 字符数 = utf8.len(文本) or 0
  local 字节数 = string.len(文本)
  local 字符表 = {}
  for _, 码点 in utf8.codes(文本) do
    字符表[#字符表+1] = string.format("U+%04X", 码点)
  end
  return table.concat(
  {
    "基本统计:",
    "字符数量: "..字符数,
    "字节长度: "..字节数,
    "",
    "字符("..#字符表.."个):",
    table.concat(字符表,", "),
    "",
    "示例处理:",
    "前5个字符: "..截取UTF8(文本,1,5),
    "后5个字符: "..截取UTF8(文本,-5)
  },
  "\n"
  )
end

function 截取UTF8(字符串, 起始索引, 结束索引)
  起始索引 = 起始索引 or 1
  结束索引 = 结束索引 or -1
  local 码点表 = {}
  for _, 码点 in utf8.codes(字符串) do
    码点表[#码点表 + 1] = 码点
  end
  if type(结束索引) == "table" then
    结束索引 = -1
  end
  if 起始索引 < 1 then
    local 起始索引 = #码点表 + 起始索引 + 1
  end
  if 结束索引 < 1 then
    local 结束索引 = #码点表 + 结束索引 + 1
  end
  起始索引 = math.max(1, math.min(起始索引, #码点表))
  结束索引 = math.min(math.max(结束索引, 1), #码点表)
  if 起始索引 > 结束索引 then
    return ""
  end
  local 结果 = {}
  for i = 起始索引, 结束索引 do
    结果[#结果 + 1] = utf8.char(码点表[i])
  end
  return table.concat(结果)
end